GNU Radio C++ API Reference: gr::fec::generic_encoder Class Reference

| GNU Radio C++ API Reference 3.10.12.0 The Free & Open Software Radio Ecosystem |

Loading...
Searching...
No Matches
gr::fec::generic_encoder Class Referenceabstract

`#include <gnuradio/fec/generic_encoder.h>`

## Public Types
typedef std::shared_ptr< generic_encoder > | sptr

## Public Member Functions
virtual void | generic_work (const void *in_buffer, void *out_buffer)=0
int | unique_id ()
std::string | alias ()
virtual double | rate ()=0
virtual int | get_input_size ()=0
virtual int | get_output_size ()=0
virtual const char * | get_input_conversion ()
virtual const char * | get_output_conversion ()
virtual bool | set_frame_size (unsigned int frame_size)=0
| generic_encoder (void)
| generic_encoder (std::string name)
virtual | ~generic_encoder ()

## Public Attributes
int | my_id
std::string | d_name

## Static Public Attributes
static int | base_unique_id

## Protected Attributes
gr::logger_ptr | d_logger

## Friends
class | encoder

## Member Typedef Documentation

## ◆ sptr

typedef std::shared_ptr<generic_encoder> gr::fec::generic_encoder::sptr

## Constructor & Destructor Documentation

## ◆ generic_encoder() [1/2]

gr::fec::generic_encoder::generic_encoder | ( | void |  | ) |
| inline

## ◆ generic_encoder() [2/2]

gr::fec::generic_encoder::generic_encoder | ( | std::string | name | ) |

## ◆ ~generic_encoder()

virtual gr::fec::generic_encoder::~generic_encoder | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ alias()

std::string gr::fec::generic_encoder::alias | ( |  | ) |

## ◆ generic_work()

virtual void gr::fec::generic_encoder::generic_work | ( | const void * | in_buffer,
|  | void * | out_buffer )
| pure virtual

Implemented in gr::fec::code::polar_encoder, and gr::fec::code::polar_encoder_systematic.

## ◆ get_input_conversion()

virtual const char * gr::fec::generic_encoder::get_input_conversion | ( |  | ) |
| virtual

Set up a conversion type required to setup the data properly for this encoder. The encoder itself will not implement the conversion and expects an external wrapper (e.g., fec.extended_encoder) to read this value and "do the right thing" to format the data.

The default behavior is 'none', which means no conversion is required. Whatever the get_input_item_size() value returns, the input is expected to conform directly to this. Generally, this means unpacked bytes.

If 'pack', the block expects the inputs to be packed bytes. The wrapper should implement a gr::blocks::pack_k_bits_bb(8) block for this.

The child class MAY implement this function. If not reimplemented, it returns "none".

Reimplemented in gr::fec::code::polar_encoder.

## ◆ get_input_size()

virtual int gr::fec::generic_encoder::get_input_size | ( |  | ) |
| pure virtual

Returns the input size in items that the encoder object uses to encode a full frame. Often, this number is the number of bits per frame if the input format is unpacked. If the block expects packed bytes, then this value should be the number of bytes (number of bits / 8) per input frame.

The child class MUST implement this function.

Implemented in gr::fec::code::ldpc_par_mtrx_encoder, gr::fec::code::polar_encoder, gr::fec::code::polar_encoder_systematic, and gr::fec::ldpc_encoder.

## ◆ get_output_conversion()

virtual const char * gr::fec::generic_encoder::get_output_conversion | ( |  | ) |
| virtual

Set up a conversion type required to understand the output style of this encoder. Generally an encoder will produce unpacked bytes with a bit set in the LSB.

The default behavior is 'none', which means no conversion is required and the encoder produces unpacked bytes.

If 'packed_bits', the block produces packed bits and the wrapper should unpack these (using, for instance, gr::block::unpack_k_bits_bb(8)).

The child class MAY implement this function. If not reimplemented, it returns "none".

Reimplemented in gr::fec::code::polar_encoder.

## ◆ get_output_size()

virtual int gr::fec::generic_encoder::get_output_size | ( |  | ) |
| pure virtual

Returns the output size in items that the encoder object produces after encoding a full frame. Often, this number is the number of bits in the outputted frame if the input format is unpacked. If the block produces packed bytes, then this value should be the number of bytes (number of bits / 8) per frame produced. This value is generally something like R*get_input_size() for a 1/R rate code.

The child class MUST implement this function.

Implemented in gr::fec::code::ldpc_par_mtrx_encoder, gr::fec::code::polar_encoder, gr::fec::code::polar_encoder_systematic, and gr::fec::ldpc_encoder.

## ◆ rate()

virtual double gr::fec::generic_encoder::rate | ( |  | ) |
| pure virtual

Returns the rate of the code. For every 1 input bit, there are r output bits, so the rate is 1/r. Used for setting things like the encoder block's relative rate.

This function MUST be reimplemented by the child class.

Implemented in gr::fec::code::cc_encoder, gr::fec::code::ccsds_encoder, gr::fec::code::dummy_encoder, gr::fec::code::ldpc_gen_mtrx_encoder, gr::fec::code::ldpc_par_mtrx_encoder, gr::fec::code::polar_encoder, gr::fec::code::polar_encoder_systematic, gr::fec::code::repetition_encoder, gr::fec::ldpc_encoder, and gr::fec::tpc_encoder.

## ◆ set_frame_size()

virtual bool gr::fec::generic_encoder::set_frame_size | ( | unsigned int | frame_size | ) |
| pure virtual

Updates the size of the frame to encode.

The child class MUST implement this function and interpret how the `frame_size` information affects the block's behavior. It should also provide bounds checks.

Implemented in gr::fec::code::cc_encoder, gr::fec::code::ccsds_encoder, gr::fec::code::dummy_encoder, gr::fec::code::ldpc_gen_mtrx_encoder, gr::fec::code::ldpc_par_mtrx_encoder, gr::fec::code::polar_encoder, gr::fec::code::polar_encoder_systematic, gr::fec::code::repetition_encoder, gr::fec::ldpc_encoder, and gr::fec::tpc_encoder.

## ◆ unique_id()

int gr::fec::generic_encoder::unique_id | ( |  | ) |

## Friends And Related Symbol Documentation

## ◆ encoder

friend class encoder
| friend

References encoder.

Referenced by encoder.

## Member Data Documentation

## ◆ base_unique_id

int gr::fec::generic_encoder::base_unique_id
| static

## ◆ d_logger

gr::logger_ptr gr::fec::generic_encoder::d_logger
| protected

## ◆ d_name

std::string gr::fec::generic_encoder::d_name

## ◆ my_id

int gr::fec::generic_encoder::my_id

The documentation for this class was generated from the following file:

- generic_encoder.h